%define	tclvers		8.2.3
%define tclXvers	8.2.0
%define	expvers		5.31
%define	Tixvers		4.1.0
%define	itclvers	3.1.0

# XXX --enable-threads ???
%define	myconfig	--enable-gcc --enable-shared

Summary: A Tcl/Tk development environment: tcl, tk, tix, tclX, expect, and itcl.
Name: tcltk
Version: %{tclvers}
Release: 36a
Source0: ftp://ftp.scriptics.com/pub/tcl/tcl8_2/tcl%{tclvers}.tar.gz
Source1: ftp://ftp.scriptics.com/pub/tcl/tcl8_2/tk%{tclvers}.tar.gz
Source2: ftp://ftp.scriptics.com/pub/tcl/expect/expect%{expvers}.tar.gz
Source3: ftp://ftp.neosoft.com/pub/tcl/TclX/tclX%{tclXvers}.tar.gz
Source4: ftp://ftp.tix.mne.com/pub/tcl/tix/Tix%{Tixvers}.006.tar.gz
Source5: ftp://ftp.scriptics.com/pub/tcl/itcl/itcl%{itclvers}.tar.gz
Source6: autopasswd
Patch0: tcltk-8.0-ieee.patch
Patch1: tcl8.0.3-glibc21.patch
Patch2: tcl8.0.5-sigpwr.patch
Patch3: tcl-%{tclvers}-cruft.patch
Patch4: tcl-%{tclvers}-bug7082.patch
Patch10: expect-5.24-mkpasswd.patch
Patch11: expect-%{expvers}-alpha.patch
Patch12: expect-5.26-glibc21.patch
Patch13: expect-5.31-jbj.patch
Patch14: expect-5.31-bug7869.patch
Patch15: expect-5.31-bug7775.patch
Patch20: tix-4.1.0.6-perf.patch
Patch21: tix-4.1.0-cruft.patch
Patch22: tix-4.1.0-tkv.patch
Patch23: tcltk-8.0.4-ppc.patch
Patch24: tclX8.2.0-lieee.patch
# XXX patch30/patch31 not applied
Patch30: tclX-8.0.4-jbj.patch
Patch31: tclX-%{tclXvers}-runtcl.patch
Copyright: BSD
Group: Development/Languages
Buildroot: /var/tmp/%{name}-root

%description
Tcl is a simple scripting language designed to be embedded into other
applications.  Tcl is designed to be used with Tk, a widget set.

%package -n tcl
#Version: %{tclvers}
Summary: An embeddable scripting language.
Group: Development/Languages
URL: http://www.scriptics.com

%description -n tcl
Tcl is a simple scripting language designed to be embedded into other
applications.  Tcl is designed to be used with Tk, a widget set, which
is provided in the tk package.  This package also includes tclsh, a
simple example of a Tcl application.

If you're installing the tcl package and you want to use Tcl for
development, you should also install the tk and tclx packages.

%package -n tk
#Version: %{tclvers}
Summary: The Tk GUI toolkit for Tcl, with shared libraries.
Group: Development/Languages
URL: http://www.scriptics.com

%description -n tk
Tk is a widget set for the X Window System that is designed to work
closely with the Tcl scripting language. It allows you to write simple
programs with full featured GUI's in only a little more time then it
takes to write a text based interface. Tcl/Tk applications can also be
run on Windows and Macintosh platforms.

%package -n expect
Version: %{expvers}
Summary: A tcl extension for simplifying program-script interaction.
Group: Development/Languages

%description -n expect
Expect is a tcl extension for automating interactive applications such
as telnet, ftp, passwd, fsck, rlogin, tip, etc.  Expect is also useful
for testing those applications.  Expect makes it easy for a script to
control another program and interact with it.

Install the expect package if you'd like to develop scripts which
interact with interactive applications.  You'll also need to install
the tcl package.

%package -n tclx
#Version: %{tclXvers}
Summary: Tcl/Tk extensions for POSIX systems.
Group: Development/Languages
URL: http://www.neosoft.com/

%description -n tclx
TclX is a set of extensions which make it easier to use the Tcl
scripting language for common UNIX/Linux programming tasks.  TclX
enhances Tcl support for files, network access, debugging, math,
lists, and message catalogs.  TclX can be used with both Tcl and
Tcl/Tk applications.

Install TclX if you are developing applications with Tcl/Tk.  You'll
also need to install the tcl and tk packages.

%package -n tix
Version: %{Tixvers}.6
Summary: A set of capable widgets for Tk.
Group: Development/Languages

%description -n tix
Tix (Tk Interface Extension), an add-on for the Tk widget set, is an
extensive set of over 40 widgets.  In general, Tix widgets are more
complex and more capable than the widgets provided in Tk.  Tix widgets
include a ComboBox, a Motif-style FileSelectBox, an MS Windows-style
FileSelectBox, a PanedWindow, a NoteBook, a hierarchical list, a
directory tree and a file manager.

Install the tix package if you want to try out more complicated
widgets for Tk.  You'll also need to have the tcl and tk packages
installed.

%package -n itcl
Version: %{itclvers}
Summary: Object-oriented mega-widgets for Tcl.
Group: Development/Languages

%description -n itcl
[incr Tcl] is an object-oriented extension of the Tcl language and was
created to support more structured programming in Tcl.  Tcl scripts
longer than a few thousand lines become extremely difficult to
maintain because the building blocks of vanilla Tcl are procedures and
global variables. All of these building blocks must reside in a single
global namespace and there is no support for protection or
encapsulation.

To help out with this problem, [incr Tcl] introduces the notion of
objects.  Each object is a bag of data with a set of procedures or
"methods" that are used to manipulate it.  Objects are organized into
"classes" with identical characteristics, and classes can inherit
functionality from one another.  This object-oriented paradigm adds
another level of organization on top of the basic variable/procedure
elements, and the resulting code is easier to understand and
maintain.

Install itcl if you're programming with Tcl, and you need the
object-oriented functionality that [incr Tcl] can provide.

%prep

%setup -q -c -a 1 -a 2 -a 3 -a 4 -a 5

cd tcl%{tclvers}
#%patch0 -p2 -b .ieee
%patch1 -p2 -b .glibc21
%patch2 -p2 -b .sigpwr
%patch3 -p2 -b .cruft
%patch4 -p2 -b .bug7082
cd ..

cd expect%{expvers}
%patch10 -p2 -b .mkpasswd
%patch11 -p2 -b .alpha
%patch12 -p2 -b .glibc21
%patch13 -p2 -b .jbj
%patch14 -p2 -b .bug7869
%patch15 -p2 -b .bug7775
cp %{SOURCE6} ./example/autopasswd
cd ..

cd Tix%{Tixvers}
ln -s tk8.0 unix/tk8.2
%patch20 -p2 -b .perf
%patch21 -p2 -b .cruft
%patch22 -p2 -b .tkv
cd ..

cd tk%{tclvers}
%patch23 -p2 -b .ppc
cd ..

cd tclX%{tclXvers}
%patch24 -p1 -b .lieee
cd ..
# XXX patch30/patch31 not applied
#cd tclX%{tclXvers}
#%patch30 -p2 -b .wrongtclXvers
#cd ..


### OK, this really touches both expect & tclX
#%patch31 -p1 -b .runtcl

# XXX this was only needed with the IEEE patch0
#cd tcl%{tclvers}/unix
#autoconf
#cd ../../
#cd tk%{tclvers}/unix
#autoconf

#==========================================
%build

# make the libraries reentrant
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D_REENTRANT -D__NO_STRING_INLINES -D__NO_MATH_INLINES"

#------------------------------------------
# Tcl
#
cd tcl%{tclvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-gcc --enable-shared

%configure %{myconfig}
mv tclConfig.sh tclConfig.sh.tmp
sed -e "s;\(TCL_CFLAGS_OPTIMIZE=\).*;\1\'$RPM_OPT_FLAGS\';" \
        tclConfig.sh.tmp > tclConfig.sh
make CFLAGS="$RPM_OPT_FLAGS"
cd ../..

#------------------------------------------
# Tk
#
cd tk%{tclvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-gcc --enable-shared

%configure %{myconfig}
make CFLAGS="$RPM_OPT_FLAGS"
cd ../..

#------------------------------------------
# tclX
#
cd tclX%{tclXvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-gcc --enable-shared

%configure %{myconfig}

# XXX drill out duplicated math libraries for now
perl -pi -e 's/ -lieee -lm//' Common.mk

make CFLAGS="$RPM_OPT_FLAGS"
cd ../..

#------------------------------------------
# Expect
#
cd expect%{expvers}
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr

%configure %{myconfig} --with-tclconfig=../tcl%{tclvers}/unix --with-tkconfig=../tk%{tclvers}/unix --with-tclinclude=../tcl%{tclvers}/generic --with-tkinclude=../tk%{tclvers}/generic

# XXX drill out HAVE_OPENPTY for now
perl -pi -e 's,HAVE_OPENPTY,HAVE_OPENPTY_BUT_DONT_USE_IT,g' expect_cf.h || :
# XXX drill in HAVE_PTMX for now
perl -pi -e 's,/* #undef HAVE_PTMX */,#define HAVE_PTMX 1,g' expect_cf.h || :

make Makefile

# XXX drill out HAVE_OPENPTY for now
perl -pi -e 's,HAVE_OPENPTY,HAVE_OPENPTY_BUT_DONT_USE_IT,g' expect_cf.h || :
# XXX drill in HAVE_PTMX for now
perl -pi -e 's,/* #undef HAVE_PTMX */,#define HAVE_PTMX 1,g' expect_cf.h || :

make CFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS"

cd ..

#------------------------------------------
# Tix
#
cd Tix%{Tixvers}/unix
#libtoolize --copy --force
#./configure --prefix=/usr --disable-cdemos --enable-shared

%configure %{myconfig} --disable-cdemos

cd tk8.0
#libtoolize --copy --force
#./configure --prefix=/usr --disable-cdemos --enable-shared \
#	--with-tcl=../../../tcl%{tclvers} --with-tk=../../../tk%{tclvers}

%configure %{myconfig} --disable-cdemos --with-tcl=../../../tcl%{tclvers} --with-tk=../../../tk%{tclvers}
make CFLAGS="$RPM_OPT_FLAGS"
cd ../../..

#------------------------------------------
# itcl
#
cd itcl%{itclvers}
#libtoolize --copy --force
#./configure --prefix=/usr --enable-shared

%configure %{myconfig} --exec-prefix=/foo
make
cd ..

#==========================================
%install
rm -rf $RPM_BUILD_ROOT
rm -f *.files*

mkdir -p $RPM_BUILD_ROOT/usr

#------------------------------------------
# Tcl
#
cd tcl%{tclvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtcl8.2.so $RPM_BUILD_ROOT/usr/lib/libtcl.so
ln -sf libtcl8.2.so $RPM_BUILD_ROOT/usr/lib/libtcl8.0.so
ln -sf tclsh8.2 $RPM_BUILD_ROOT/usr/bin/tclsh
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | sort > tcl.files

#------------------------------------------
# Tk
#
cd tk%{tclvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtk8.2.so $RPM_BUILD_ROOT/usr/lib/libtk.so
ln -sf libtk8.2.so $RPM_BUILD_ROOT/usr/lib/libtk8.0.so
ln -sf wish8.2 $RPM_BUILD_ROOT/usr/bin/wish
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files \
	| sort | uniq -u > tk.files

#------------------------------------------
# TclX
#
cd tclX%{tclXvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtkx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtkx.so
ln -sf libtclx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtclx.so
ln -sf libtkx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtkx8.0.so
ln -sf libtclx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtclx8.0.so
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files \
	| sort | uniq -u > tclx.files

#------------------------------------------
# Expect
#
cd expect%{expvers}
make prefix=$RPM_BUILD_ROOT/usr install
cd ..

# remove cryptdir/decryptdir, as Linux has not crypt command (#6668).
rm -f $RPM_BUILD_ROOT/usr/bin/{cryptdir,decryptdir}
rm -f $RPM_BUILD_ROOT/usr/man/man1/{cryptdir,decryptdir}.1*

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files \
	| sort | uniq -u > expect.files

# for files in expect.files, sed the #! at the top...
set +x
for n in `cat expect.files`; do
	[ -f $n ] || continue
	head -1 $n | grep '^#!' > /dev/null 2>&1 || continue
	chmod u+w $n
	perl -pi -e "s|$RPM_BUILD_ROOT||" $n
done
set -x

#------------------------------------------
# Tix
#
cd Tix%{Tixvers}/unix
LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/lib make prefix=$RPM_BUILD_ROOT/usr install
cd ../..
mv $RPM_BUILD_ROOT/usr/man/mann/tixwish.1 $RPM_BUILD_ROOT/usr/man/man1/tixwish.1
ln -sf libtix4.1.8.2.so $RPM_BUILD_ROOT/usr/lib/libtix.so
ln -sf libtix4.1.8.2.so $RPM_BUILD_ROOT/usr/lib/libtix4.1.8.0.so
ln -sf libtixsam4.1.8.2.so $RPM_BUILD_ROOT/usr/lib/libtixsam.so
ln -sf tixwish4.1.8.2 $RPM_BUILD_ROOT/usr/bin/tixwish
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files expect.files\
	| sort | uniq -u > tix.files

set +x
for n in `cat tix.files`; do
	[ -f $n ] || continue
	head -1 $n | grep '^#!' > /dev/null 2>&1 || continue
	chmod u+w $n
	perl -pi -e "s|$RPM_BUILD_ROOT||" $n
done
set -x

#------------------------------------------
# itcl
#
cd itcl%{itclvers}
make INSTALL_ROOT=$RPM_BUILD_ROOT exec_prefix=/usr INSTALL="install -c" MKINSTALLDIRS="mkdir -p" install
ln -sf libitk3.1.so $RPM_BUILD_ROOT/usr/lib/libitk.so
ln -sf libitcl3.1.so $RPM_BUILD_ROOT/usr/lib/libitcl.so
ln -sf itclsh3.1 $RPM_BUILD_ROOT/usr/bin/itclsh
ln -sf itkwish3.1 $RPM_BUILD_ROOT/usr/bin/itkwish
cd ..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files expect.files tix.files \
	| sort | uniq -u > itcl.files

set +x
for n in `cat itcl.files`; do
	[ -f $n ] || continue
	head -1 $n | grep '^#!' > /dev/null 2>&1 || continue
	chmod u+w $n
	perl -pi -e "s|$RPM_BUILD_ROOT||" $n
done
set -x

#------------------------------------------
# this is too annoying to watch
set +x
for n in *.files; do
	mv $n $n.in
	sed "s|.*/usr|/usr|" < $n.in | while read file; do
	    if [ -d $RPM_BUILD_ROOT/$file ]; then
		echo -n '%dir '
	    fi
	    echo $file
	done > $n
	rm -f $n.in
done
set -x

# Strip the binaries
strip $RPM_BUILD_ROOT/usr/bin/* > /dev/null 2>&1 || :

# Man pages can be compressed
perl -pi -e 's|(^/usr/man/man.*$)|\1\*|' *.files

#==========================================
%post -p /sbin/ldconfig -n tcl
%post -p /sbin/ldconfig -n tk
%post -p /sbin/ldconfig -n expect
%post -p /sbin/ldconfig -n tclx
%post -p /sbin/ldconfig -n tix
%post -p /sbin/ldconfig -n itcl

%postun -p /sbin/ldconfig -n tcl
%postun -p /sbin/ldconfig -n tk
%postun -p /sbin/ldconfig -n expect
%postun -p /sbin/ldconfig -n tclx
%postun -p /sbin/ldconfig -n tix
%postun -p /sbin/ldconfig -n itcl

%clean
rm -rf $RPM_BUILD_ROOT
rm -f *.files*

%files -f tcl.files -n tcl
%files -f tk.files -n tk
%files -f tclx.files -n tclx
%files -f expect.files -n expect
%files -f tix.files -n tix
%files -f itcl.files -n itcl

%changelog
* Sat May 20 2000 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- built against linuxppc-2000.

* Sat Mar 18 2000 Jeff Johnson <jbj@redhat.com>
- update to (tcl,tk}-8.2.3, expect-5.31, and itcl-3.1.0, URL's as well.
- use perl to drill out pre-pended RPM_BUILD_ROOT.
- configure with --enable-threads (experimental).
- improved version of autopasswd (#4788).
- autopasswd needs to handle password starting with hyphen (#9917).
- handle 553 ftp status in rftp expect script (#7869).
- remove cryptdir/decryptdir, as Linux has not crypt command (#6668).
- correct hierarchy spelling (#7082).
- fix "expect -d ...", format string had int printed as string (#7775).

* Tue Mar  7 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for sparc baud rates > 38400.

* Mon Feb  7 2000 Bill Nottingham <notting@redhat.com>
- handle compressed manpages

* Thu Feb 03 2000 Elliot Lee <sopwith@redhat.com>
- Make changes from bug number 7602
- Apply patch from bug number 7537
- Apply fix from bug number 7157
- Add fixes from bug #7601 to the runtcl patch

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix descriptions
- man pages are compressed (whatapain)

* Tue Nov 30 1999 Jakub Jelinek <jakub@redhat.com>
- fix tclX symlinks.
- compile on systems where SIGPWR == SIGLOST.

* Sat May  1 1999 Jeff Johnson <jbj@redhat.com>
- update tcl/tk to 8.0.5.
- avoid "containing" in Tix (#2332).

* Thu Apr  8 1999 Jeff Johnson <jbj@redhat.com>
- use /usr/bin/write in kibitz (#1320).
- use cirrus.sprl.umich.edu in weather (#1926).

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 28)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- whoops, exec-prefix for itcl was set to '/foo', changed to '/usr'.

* Tue Feb 16 1999 Jeff Johnson <jbj@redhat.com>
- expect does unaligned access on alpha (#989)
- upgrade tcl/tk/tclX to 8.0.4
- upgrade expect to 5.28.
- add itcl 3.0.1

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize to allow building on the arm
- build for glibc 2.1
- strip binaries

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update tcl/tk/tclX to 8.0.3, expect is updated also.

* Mon Jun 29 1998 Jeff Johnson <jbj@redhat.com>
- expect: mkpasswd needs delay before sending password (problem #576)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed expect binaries exec permissions

* Thu Apr 09 1998 Erik Troan <ewt@redhat.com>
- updated to Tix 4.1.0.006
- updated version numbers of tcl/tk to relflect includsion of p2

* Wed Mar 25 1998 Cristian Gafton <gafton@redhat.com>
- updated tcl/tk to patch level 2
- updated tclX to 8.0.2

* Thu Oct 30 1997 Otto Hammersmith <otto@redhat.com>
- fixed filelist for tix... replacing path to the expect binary in scripts
  was leaving junk files around.

* Wed Oct 22 1997 Otto Hammersmith <otto@redhat.com>
- added patch to remove libieee test in configure.in for tcl and tk.
  Shoudln't be needed anymore for glibc systems, but this isn't the "proper" 
  solution for all systems
- fixed src urls

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- removed version numbers from descriptions

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- updated to tcl/tk 8.0 and related versions of packages

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
- fixed dangling tclx/tkx symlinks
